// enumfolder.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <windows.h>

#include <tchar.h>
#include <shlobj.h>
#include <shlwapi.h>

#pragma comment(lib, "shlwapi.lib")

int main()
{
    CoInitialize(NULL);

    IShellFolder *Shell = NULL;
    HRESULT hRes = SHGetDesktopFolder(&Shell);
    if( SUCCEEDED(hRes) )
    {
        LPITEMIDLIST networkPidl = NULL;
        hRes = SHGetSpecialFolderLocation(NULL, /*CSIDL_NETHOOD*/CSIDL_NETWORK, &networkPidl);
        if( SUCCEEDED(hRes) )
        {
            IShellFolder *networkFolder = NULL;
            hRes = Shell->BindToObject(networkPidl, NULL, IID_IShellFolder, (void**)&networkFolder);
            if( SUCCEEDED(hRes) )
            {
                IEnumIDList *networkEnum = NULL;
                hRes = networkFolder->EnumObjects(NULL, SHCONTF_FOLDERS, &networkEnum);
                if( SUCCEEDED(hRes) )
                {
                    LPITEMIDLIST childPidl = NULL;
                    TCHAR szName[256];

                    hRes = networkEnum->Reset();
                    do
                    {
                        hRes = networkEnum->Next(1, &childPidl, NULL);
                        if( hRes != S_OK )
                            break;

                        STRRET str;
                        networkFolder->GetDisplayNameOf(childPidl, SHGDN_NORMAL, &str);

                        StrRetToBuf(&str, childPidl, szName, 256);

                        printf("%ls\n", szName);
                        
                        CoTaskMemFree(childPidl);
                        childPidl = NULL;
                    }
                    while( true );

                    networkEnum->Release();
                }

                networkFolder->Release();
            }

            CoTaskMemFree(networkPidl);
        }

        Shell->Release();
    }

    CoUninitialize();
    return 0;
}
